import random

from faker import Faker
from pytest import fixture


@fixture(scope='module')
def the_faker():
    p_faker = Faker(['pt-BR'])
    p_faker.seed_instance(random.randint(0, 999))
    return p_faker


@fixture(scope='function')
def new_client(the_faker):
    return {
        'name': the_faker.company().upper(),
        'nrle_id': the_faker.cnpj()
    }


@fixture(scope='function')
def new_nfse(the_faker):
    def _new_nfse(client):
        return {
            'client': client,
            'nfse_number': the_faker.random_number(digits=7),
            'service_value': the_faker.random_number(digits=4),
            'services_provided': the_faker.text(max_nb_chars=20),
        }
    return _new_nfse


@fixture(scope='function')
def new_clients(the_faker):
    def _new_clients(number_of_clients):
        clients = []
        for _ in range(number_of_clients):
            clients.append({
                'name': the_faker.company().upper(),
                'nrle_id': the_faker.cnpj()})

        return clients

    return _new_clients
