from .utils import with_test_db
from alyaht.models import Client


@with_test_db([Client])
def test_create_client(new_client):
    expected = new_client
    Client.create(**expected)

    client = Client.get(Client.name == expected['name'])

    assert expected['name'] == client.name
    assert expected['nrle_id'] == client.nrle_id


@with_test_db([Client])
def test_find_client_by_id(new_client):
    expected_id = 1
    Client.create(**new_client)

    client = Client.find_client_by_id(expected_id)

    assert client.id == expected_id


@with_test_db([Client])
def test_find_client_by_nrle(new_client):
    expected = new_client
    Client.create(**expected)

    client = Client.find_client_by_nrle(expected['nrle_id'])

    assert client.nrle_id == expected['nrle_id']


@with_test_db([Client])
def test_insert_many_clients(new_clients):
    expected = new_clients(3)
    Client.insert_many(expected).execute()

    number_of_clients = len(Client.select())

    assert number_of_clients == len(expected)
