from .utils import with_test_db
from alyaht.models import Client
from alyaht.models import Nfse


@with_test_db([Client, Nfse])
def test_create_nfse(new_client, new_nfse):
    Client.create(**new_client)
    expected = new_nfse(Client.find_client_by_id(1))

    Nfse.create(**expected)

    nfse = Nfse.get(Nfse.nfse_number == expected['nfse_number'])

    assert nfse.nfse_number == expected['nfse_number']


@with_test_db([Client, Nfse])
def test_find_nfse_by_number(new_client, new_nfse):
    Client.create(**new_client)
    expected = new_nfse(Client.find_client_by_id(1))

    Nfse.create(**expected)

    nfse = Nfse.find_nfse_by_number(expected['nfse_number'])

    assert nfse.nfse_number == expected['nfse_number']


@with_test_db([Client, Nfse])
def test_find_nfse_by_client(new_client, new_nfse):
    Client.create(**new_client)
    client = Client.find_client_by_id(1)
    expected = new_nfse(client)

    Nfse.create(**expected)

    nfse = Nfse.find_nfse_by_client(client)

    assert nfse[0].client == client
